express = require "express"
app = express()
require("../../src/main").use app

describe 'mapping::', ->
  agent = superagent.agent()
  port = 9090

  methods = [
    'get'
    'post' 
    'put'
    'patch'
    'delete'
    'copy'
    'head'
    'options'
    'purge'
    'trace'
  ]

  before ->
    routeHandler = (req, res) ->
      res.send(req.method.toLowerCase())
    mapper = routes: {}
    for method in methods
      mapper.routes[method] = routeHandler
    app.routeMapper mapper

  #==============================================================================
  # basic test
  #==============================================================================
  for method in methods
    it "should has #{method} route", (done) ->
      supertest(app)[method]('/').expect(200, done)