express = require "express"
app = express()
require("../../src/main").use app

describe 'mapping before route renders ::', ->
  agent = superagent.agent()

  methods = [
    'get'
    'post' 
    'put'
    'patch'
    'delete'
    'copy'
    'head'
    'options'
    'purge'
    'trace'
  ]

  before ->
    mapper = routes: {}

    handleRoute = (req, res) ->
      res.send req.method.toLowerCase()

    handleRoute.before = (req, res) ->
      res.status(500).end()

    for method in methods
      mapper.routes[method] = handleRoute

    app.routeMapper mapper

  #==============================================================================
  # basic test
  #==============================================================================
  for method in methods
    it "should has #{method} route", (done) ->
      supertest(app)[method]('/').expect(500, done)


